> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zdns/private-zone/addprivatezone.md).

# AddPrivateZone

## 1. API Description

This API (AddPrivateZone) is used to create a DNS Zone.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name  | Required | Type                                                                  | Description                                                                                                                                                                          |
| --------------- | -------- | --------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| zoneName        | Yes      | String                                                                | <p>Domain name.</p><p>It must be in domain name format and up to 252 characters long, or a standalone domain suffix without dots (2-63 characters long).</p><p>Case-insensitive.</p> |
| proxyPattern    | No       | [ProxyPattern](/api-reference/zdns/datastructure.md#proxypattern)     | <p>Whether to enable subdomain recursive resolution proxy.</p><p>Default value: ZONE</p>                                                                                             |
| vpcIds          | No       | Array of String                                                       | <p>List of VPC IDs to be associated.</p><p>It can be obtained by calling <a href="/api-reference/zec/vpc-network/describevpcs.md">DescribeVpcs</a>.</p>                              |
| resourceGroupId | No       | String                                                                | Resource group ID.                                                                                                                                                                   |
| remark          | No       | String                                                                | <p>Note information.</p><p>The length is up to 255 characters.</p>                                                                                                                   |
| tags            | No       | [TagAssociation](/api-reference/zdns/datastructure.md#tagassociation) | Bound tags.                                                                                                                                                                          |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| zoneId         | String | ID of the created DNS Zone.                                                                                           |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Create a DNS Zone.**

```json
POST /api/v2/zdns HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: AddPrivateZone
<Common Request Params>

Request：
{
  "zoneName": "example.com",
  "proxyPattern": "ZONE",
  "remark": "Test Zone",
  "tags": {
    "tags": [
      {
        "key": "mykey",
        "value": "test"
      }
    ]
  }
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
    "zoneId": "<zoneId>"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code          | Description              |
| ---------------- | ------------------- | ------------------------ |
| 400              | INVALID\_ZONE\_NAME | Invalid DNS Zone format. |
